﻿using SMBLibrary.Client;
using System;
using System.Collections.Generic;
using System.Text;

namespace SMBLibrary.Win32.Security
{
    public class IntegratedNTLMClientAuthentication : INTLMClientAuthentication
    {
        private readonly string m_userName;
        private readonly string m_domainName;
        private readonly string m_password;
        private readonly string m_targetName;
        private SecHandle m_context;

        public IntegratedNTLMClientAuthentication(string userName, string domainName, string password, string targetName)
        {
            m_userName = userName;
            m_domainName = domainName;
            m_password = password;
            m_targetName = targetName;
        }
        

        public byte[] GetAuthenticateMessage(byte[] securityBlob, out byte[] sessionKey)
        {
            byte[] ret = SSPIHelper.GetType3Message(m_context, m_targetName, securityBlob);
            sessionKey = SSPIHelper.GetSessionKey(m_context);
            SSPIHelper.DeleteSecurityContext(ref m_context);
            return ret;
        }

        public byte[] GetNegotiateMessage(byte[] securityBlob)
        {
            return SSPIHelper.GetType1Message(m_domainName, m_userName, m_password, m_targetName, out m_context);
        }
    }
}
