﻿using System;
using System.Collections.Generic;
using System.Text;

namespace SMBLibrary.Client
{
    public class NTLMAuthentication : INTLMClientAuthentication
    {
        private readonly string m_userName;
        private readonly string m_domainName;
        private readonly string m_password;
        private readonly AuthenticationMethod m_authenticationMethod;

        public NTLMAuthentication(string userName, string domainName, string password, AuthenticationMethod authenticationMethod)
        {
            m_userName = userName;
            m_domainName = domainName;
            m_password = password;
            m_authenticationMethod = authenticationMethod;
        }

        public byte[] GetAuthenticateMessage(byte[] securityBlob, out byte[] sessionKey)
        {
            return NTLMAuthenticationHelper.GetAuthenticateMessage(securityBlob, m_domainName,
                            m_userName, m_password, m_authenticationMethod, out sessionKey);
        }

        public byte[] GetNegotiateMessage(byte[] securityBlob)
        {
            return NTLMAuthenticationHelper.GetNegotiateMessage(securityBlob, m_domainName, m_authenticationMethod);
        }
    }
}
